#include <stdlib.h>
#include <stdio.h>
#include <strings.h>
#include <math.h>
#include "vector.h"
#include "poly.h"

/*****************************************************
 Op|SȂʏ̓_ Op|S̓
 邩ǂ𔻒肷
*****************************************************/
int Poly_CheckInside( struct Vec3D *faceP0, struct Vec3D *faceP1, struct Vec3D *faceP2,
                      struct Vec3D *pos )
{
  double    dp ;
  struct Vec3D   vec0, vec1, fvec0, fvec1 ;
  
  SubVec( pos, faceP0, &vec0 );
  SubVec( pos, faceP1, &vec1 );
  CrossProduct( &vec0,&vec1,&fvec0 ) ;
  
  SubVec( pos, faceP1, &vec0 );
  SubVec( pos, faceP2, &vec1 );
  CrossProduct( &vec0,&vec1,&fvec1 ) ;
  dp = DotProduct( &fvec0, &fvec1 );
  if( dp<0.0 ) return(0) ;
  
  SubVec( pos, faceP2, &vec0 );
  SubVec( pos, faceP0, &vec1 );
  CrossProduct( &vec0,&vec1,&fvec1 ) ;
  dp = DotProduct( &fvec0, &fvec1 );
  if( dp<0.0 ) return(0) ;
  
  return(1) ;
}


/*****************************************************
 ʂƒ̌_߂
*****************************************************/
int Poly_SearchCorssPoint( struct Vec3D *eyepos, struct Vec3D *ray,
			   struct Vec3D *faceP0, struct Vec3D *faceN,
			   struct Vec3D *pos )
{
  double        a,b,t;
  struct Vec3D  vec;

  SubVec( faceP0, eyepos, &vec ) ;
  
  a=DotProduct(&vec, faceN) ;
  b=DotProduct( ray, faceN) ;

  if( b==0.0 ) return(0) ;

  t = a/b ;
  
  pos->x = eyepos->x + ray->x * t;
  pos->y = eyepos->y + ray->y * t;
  pos->z = eyepos->z + ray->z * t;
  
  return(1);
}
